@********************************************************************
@ crt0.s                                                            *
@********************************************************************
    .TEXT

    .GLOBAL     _start
_start:
        .ALIGN
        .CODE 32
        @ Start Vector
rom_header:     b       rom_header_end @+ 0x01000000

        @ Nintendo Logo Character Data (8000004h)
                .byte    0x24,0xFF,0xAE,0x51,0x69,0x9A,0xA2,0x21
                .byte    0x3D,0x84,0x82,0x0A,0x84,0xE4,0x09,0xAD
                .byte    0x11,0x24,0x8B,0x98,0xC0,0x81,0x7F,0x21
                .byte    0xA3,0x52,0xBE,0x19,0x93,0x09,0xCE,0x20
                .byte    0x10,0x46,0x4A,0x4A,0xF8,0x27,0x31,0xEC
                .byte    0x58,0xC7,0xE8,0x33,0x82,0xE3,0xCE,0xBF
                .byte    0x85,0xF4,0xDF,0x94,0xCE,0x4B,0x09,0xC1
                .byte    0x94,0x56,0x8A,0xC0,0x13,0x72,0xA7,0xFC
                .byte    0x9F,0x84,0x4D,0x73,0xA3,0xCA,0x9A,0x61
                .byte    0x58,0x97,0xA3,0x27,0xFC,0x03,0x98,0x76
                .byte    0x23,0x1D,0xC7,0x61,0x03,0x04,0xAE,0x56
                .byte    0xBF,0x38,0x84,0x00,0x40,0xA7,0x0E,0xFD
                .byte    0xFF,0x52,0xFE,0x03,0x6F,0x95,0x30,0xF1
                .byte    0x97,0xFB,0xC0,0x85,0x60,0xD6,0x80,0x25
                .byte    0xA9,0x63,0xBE,0x03,0x01,0x4E,0x38,0xE2
                .byte    0xF9,0xA2,0x34,0xFF,0xBB,0x3E,0x03,0x44
                .byte    0x78,0x00,0x90,0xCB,0x88,0x11,0x3A,0x94
                .byte    0x65,0xC0,0x7C,0x63,0x87,0xF0,0x3C,0xAF
                .byte    0xD6,0x25,0xE4,0x8B,0x38,0x0A,0xAC,0x72
                .byte    0x21,0xD4,0xF8,0x07
        @ Software Titles (80000A0h)
                .byte   0x46,0x2D,0x5A,0x45,0x52,0x4F,0x20,0x41
                .byte   0x44,0x56,0x41,0x4E
        @ Initial Code (80000ACh)
                  .byte   0x41,0x46,0x5A,0x4A

        @ Maker Code (80000B0h)
                .byte   0x30,0x31

        @ Fixed Value (80000B2h)
                .byte   0x96

        @ Main Unit Code (80000B3h)
                .byte   0x00

        @ Device Type (80000B4h)
                .byte   0x00

        @ Unused Data (7Byte) (80000B5h)
                .byte   0x00,0x00,0x00,0x00,0x00,0x00,0x00

        @ Software Version No (80000BCh)
                .byte   0x00

        @ Complement Check (80000BDh)
                .byte   0x88

        @ Check Sum (80000BEh)
                .byte   0x00,0x00
        @ Multiboot entrypoint (0xC0)
                b       rom_header_end
        @ Boot mode (0xC4)
                .byte   0x00
        @ Slave ID (0xC5)
                .byte   0x00
        @ 20000C6h..20000DFh - Not used
                .byte   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
                .byte   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
                .byte   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
        @ Joybus entrypoint (0xE0)
                b       rom_header_end
endless:
        b     endless
rom_header_end:

@--------------------------------------------------------------------
@-                          Reset                                   -
@--------------------------------------------------------------------
    .EXTERN     main
    .GLOBAL     start_vector
    .CODE 32
    .ALIGN
start_vector:
        mov     r0, #0x12               @ Switch to IRQ Mode
        msr     cpsr, r0
        ldr     sp, sp_irq              @ Set SP_irq
        mov     r0, #0x1f               @ Switch to System Mode
        msr     cpsr, r0
        ldr     sp, sp_usr              @ Set SP_usr
        str     r0, [r1]
        ldr     r1, =main            @ Start & Switch to 16bit Code
        mov     lr, pc
        bx      r1
        b       start_vector            @ Reset

    .ALIGN
sp_usr: .word   0x3008000 - 0x100
sp_irq: .word   0x3008000 - 0x60

    .ALIGN
    .CODE 32

    .END

